<template>
  <button :class="buttonClass" @click="onClick">
    <slot></slot>
  </button>
</template>

<script setup lang="ts">
import { defineProps, defineEmits, computed } from 'vue'

interface ButtonProps {
  variant?: 'primary' | 'secondary' | 'danger'
  disabled?: boolean
}

const props = defineProps<ButtonProps>()
const emit = defineEmits(['click'])

const onClick = (event: Event) => {
  if (!props.disabled) {
    emit('click', event)
  }
}

const buttonClass = computed(() => {
  let baseClass = 'px-4 py-2 rounded focus:outline-none'
  switch (props.variant) {
    case 'primary':
      baseClass += ' bg-blue-500 text-white hover:bg-blue-600'
      break
    case 'secondary':
      baseClass += ' bg-gray-500 text-white hover:bg-gray-600'
      break
    case 'danger':
      baseClass += ' bg-red-500 text-white hover:bg-red-600'
      break
    default:
      baseClass += ' bg-gray-500 text-white hover:bg-gray-600'
  }
  if (props.disabled) {
    baseClass += ' opacity-50 cursor-not-allowed'
  }
  return baseClass
})
</script>
